/*************************************************
 **                                             **
 **   idx.h                                     **
 **                                             **
 **          Copyright (C) 1990-1992 by         **
 **               SoftC, Ltd.                   **
 **               16820 3rd St NE               **
 **               Anoka, MN 55304               **
 **               (612) 434-6968                **
 **                                             **
 **             All rights reserved.            **
 *************************************************/



#ifndef __SOFTC_H__
#include "softc.h"
#endif



/**********
 *
 *  Type Definitions
 *
 **********/




typedef struct {  /* FoxBASE index file information packet */
  CHAR fname[80]; /* file name */
  SC_FLAGS flags; /* miscellaneous flags */
  INT keylen;     /* key length */
  INT keytype;    /* key type */
  INT keyfmt;     /* key format (Unique, etc.) */
  INT lockt;      /* file lock/unlock flag */
  INT exprlen;    /* key expression length */
  CHAR expr[100]; /* first 100 characters of index expression */
} SC_IDXINFO;



#ifdef __ANSI_PROTOTYPES__
#ifdef __cplusplus
extern "C" {
#endif


/**********
 *
 *  FoxBASE+/FoxPro Index File Manipulators Prototypes
 *
 **********/




INT PROTOS scdibfrsz(  INT,              /* index file handle */
		       INT F_PTR,        /* buffer length in pages */
		       INT );            /* set or get buffer length */

INT PROTOS scdiclose(  INT );            /* file handle */

INT PROTOS scdicreate( CHAR F_PTR,       /* filename */
		       INT,              /* index key type */
		       CHAR F_PTR ,      /* key expression */
		       INT );            /* key length */

INT PROTOS scdiexpr(   INT,              /* file handle */
		       CHAR F_PTR );     /* key expression */

INT PROTOS scdiflush(  INT );            /* file handle */

INT PROTOS scdihget(   INT );            /* file handle */

INT PROTOS scdiindex(  INT,              /* data file handle */
		       CHAR F_PTR,       /* new file name */
		       INT,              /* index key type */
		       CHAR F_PTR,       /* key expression */
		       INT );            /* key length */

INT PROTOS scdiinfo(   INT,              /* file handle */
		       SC_IDXINFO F_PTR );/* file information and status */

INT PROTOS scdilock(   INT );            /* file handle */

INT PROTOS scdiopenx(  INT F_PTR,        /* file handle */
		       CHAR F_PTR,       /* filename */
		       INT );            /* open mode and characteristics */

INT PROTOS scdiunlock( INT );            /* file handle */




/**********
 *
 *  FoxBASE+/FoxPro Index Key Building Prototypes
 *
 **********/




INT PROTOS scdikdate(  CHAR F_PTR,       /* FoxBASE date */
		       CHAR F_PTR,       /* date string */
		       INT );            /* date string format type */

INT PROTOS scdikmake(  INT,              /* .DBF file handle */
		       INT,              /* .NTX file handle */
		       VOID F_PTR F_PTR ); /* index key */

INT PROTOS scdiknum(   CHAR F_PTR,       /* FoxBASE DOUBLE */
		       DOUBLE );         /* C DOUBLE */






/**********
 *
 *  FoxBASE+/FoxPro Index Key Manipulator Prototypes
 *
 **********/




INT PROTOS scdikadd(   INT,              /* file handle */
		       VOID F_PTR,       /* key string */
		       LONG );           /* data record number */

INT PROTOS scdikbot(   INT,              /* file handle */
		       VOID F_PTR,       /* key string */
		       LONG F_PTR);      /* data record number */

INT PROTOS scdikcur(   INT,              /* file handle */
		       VOID F_PTR,       /* key string */
		       LONG F_PTR);      /* data record number */

INT PROTOS scdikdel(   INT,              /* file handle */
		       VOID F_PTR,       /* key string */
		       LONG );           /* data record number */

INT PROTOS scdikfind(  INT,              /* file handle */
		       VOID F_PTR,       /* key string */
		       LONG F_PTR,       /* data record number */
		       INT);             /* exact match or first */

INT PROTOS scdiknext(  INT,              /* file handle */
		       VOID F_PTR,       /* key string */
		       LONG F_PTR);      /* data record number */

INT PROTOS scdikprev(  INT,              /* file handle */
		       VOID F_PTR,       /* key string */
		       LONG F_PTR);      /* data record number */

INT PROTOS scdiktop(   INT,              /* file handle */
		       VOID F_PTR,       /* key string */
		       LONG F_PTR);      /* data record number */





#ifdef __cplusplus
}
#endif
#endif


